import { renderInternal, _CI, _HI, _M, _MCCC, _ME, _MFCC, _MP, _MR, Component, createComponentVNode, createFragment, createPortal, createRef, createRenderer, createTextVNode, createVNode, directClone, EMPTY_OBJ, findDOMFromVNode, forwardRef, Fragment, getFlagsForElementVnode, type InfernoNode, linkEvent, normalizeProps, options, rerender, type VNode } from 'inferno';
import { hydrate } from 'inferno-hydrate';
import { cloneVNode } from 'inferno-clone-vnode';
import { createElement } from 'inferno-create-element';
import { isValidElement } from './isValidElement';
import PropTypes from './PropTypes';
import { findDOMNode } from 'inferno-extras';
export type { ComponentType, Inferno, Refs, VNode } from 'inferno';
declare global {
    interface Event {
        persist: Function;
    }
}
declare function unmountComponentAtNode(container: Element | SVGAElement | DocumentFragment): boolean;
export type IterateChildrenFn = (value: InfernoNode | any, index: number, array: any[]) => any;
declare const Children: {
    map(children: any[], fn: IterateChildrenFn, ctx: any): any[];
    forEach(children: any[], fn: IterateChildrenFn, ctx?: any): void;
    count(children: any[]): number;
    only(children: any[]): InfernoNode | any;
    toArray(children: any[]): any[];
};
declare const version = "15.4.2";
declare abstract class PureComponent<P, S> extends Component<P, S> {
    shouldComponentUpdate(props: any, state: any): boolean;
}
declare function unstable_renderSubtreeIntoContainer(parentComponent: any, vNode: any, container: any, callback: any): Component;
declare function createFactory(type: any): (type: any) => VNode;
declare function render(rootInput: any, container: any, cb?: null, context?: {}): Component | undefined;
export { Children, Component, EMPTY_OBJ, Fragment, PropTypes, PureComponent, _CI, _HI, _M, _MCCC, _ME, _MFCC, _MP, _MR, renderInternal, cloneVNode as cloneElement, cloneVNode, createComponentVNode, createElement, createFactory, createFragment, createPortal, createRef, createRenderer, createTextVNode, createVNode, directClone, findDOMNode, findDOMFromVNode, forwardRef, getFlagsForElementVnode, hydrate, isValidElement, linkEvent, normalizeProps, options, render, rerender, unmountComponentAtNode, unstable_renderSubtreeIntoContainer, version, };
declare const _default: {
    Children: {
        map(children: any[], fn: IterateChildrenFn, ctx: any): any[];
        forEach(children: any[], fn: IterateChildrenFn, ctx?: any): void;
        count(children: any[]): number;
        only(children: any[]): InfernoNode | any;
        toArray(children: any[]): any[];
    };
    Component: typeof Component;
    EMPTY_OBJ: {};
    Fragment: import("inferno").Inferno.ExoticComponent<{
        children?: InfernoNode;
    }>;
    PropTypes: {
        any: () => Function;
        array: () => void;
        arrayOf: () => Function;
        bool: () => void;
        checkPropTypes: () => null;
        element: () => Function;
        func: () => void;
        instanceOf: () => Function;
        node: () => Function;
        number: () => void;
        object: () => void;
        objectOf: () => Function;
        oneOf: () => Function;
        oneOfType: () => Function;
        shape: () => Function;
        string: () => void;
        symbol: () => void;
    };
    PureComponent: typeof PureComponent;
    _CI: typeof _CI;
    _HI: typeof _HI;
    _M: typeof _M;
    _MCCC: typeof _MCCC;
    _ME: typeof _ME;
    _MFCC: typeof _MFCC;
    _MP: typeof _MP;
    _MR: typeof _MR;
    __render: typeof renderInternal;
    cloneElement: typeof cloneVNode;
    cloneVNode: typeof cloneVNode;
    createComponentVNode: typeof createComponentVNode;
    createElement: typeof createElement;
    createFactory: typeof createFactory;
    createFragment: typeof createFragment;
    createPortal: typeof createPortal;
    createRef: typeof createRef;
    createRenderer: typeof createRenderer;
    createTextVNode: typeof createTextVNode;
    createVNode: typeof createVNode;
    directClone: typeof directClone;
    findDOMFromVNode: typeof findDOMFromVNode;
    findDOMNode: typeof findDOMNode;
    forwardRef: typeof forwardRef;
    getFlagsForElementVnode: typeof getFlagsForElementVnode;
    hydrate: typeof hydrate;
    isValidElement: typeof isValidElement;
    linkEvent: typeof linkEvent;
    normalizeProps: typeof normalizeProps;
    options: {
        createVNode: ((vNode: VNode) => void) | null;
        reactStyles?: boolean;
    };
    render: typeof render;
    rerender: typeof rerender;
    unmountComponentAtNode: typeof unmountComponentAtNode;
    unstable_renderSubtreeIntoContainer: typeof unstable_renderSubtreeIntoContainer;
    version: string;
};
export default _default;
